#ifndef __OSAMCC30_H__
#define __OSAMCC30_H__



#if   defined(__PIC24F__)
#include <p24Fxxxx.h>
#elif defined(__PIC24H__)
#include <p24Hxxxx.h>
#elif defined(__dsPIC30F__)
#include <p30Fxxxx.h>
#elif defined(__dsPIC33F__)
#include <p33Fxxxx.h>
#else
#warning "ATTENTION! PIC type not defined!"
#endif



/*************************************************************************************************************************/
//------------------------------------------------------------------------------
#define _PIC18_ERRATA_NOP()  

#define _SET_TASK_IRP()      //    PIC16,   -  



#define OST_CODE_POINTER    unsigned long    //     
#define OS_CODE_POINTER_SIZE    4


#define OST_TASK_POINTER   OS_TASKS_BANK OST_TCB *



#define OS_CLRWDT()   asm volatile(" clrwdt ")
#define OS_ClrWdt()   asm volatile(" clrwdt ")
#define OS_SLEEP()    asm volatile(" pwrsav #0  ")
#define OS_Sleep()    asm volatile(" pwrsav #0  ")
#define OS_IDLE()     asm volatile(" pwrsav #1  ")
#define OS_Idle()     asm volatile(" pwrsav #1  ")


//______________________________________________________________________________


    #define _OS_SetPC()
    
    #define _OS_SavePC()


    #define _OS_JumpToTask()                                                \
        {                                                                   \
            asm volatile("   goto    _os_call_goto_task          ");        \
            asm volatile("_os_goto_task:                         ");        \
            asm volatile("   mov     __OS_CurTask, w0             ");       \
            asm volatile("   mov     [w0 + #0], w1               ");        \
            asm volatile("   mov     w1, _OS_state                ");       \
            asm volatile("   mov     [w0 + #2], w2               ");        \
            asm volatile("   mov     [w0 + #4], w3               ");        \
            asm volatile("   mov     [w0 + #6], w4               ");        \
            /*  link  */                                       \
            asm volatile("   push    w14                         ");        \
            asm volatile("   mov     w15, w14                    ");        \
            asm volatile("   add     w4, w14, w15                ");        \
            /*       */                         \
            asm volatile("   push.d  w2                          ");        \
            asm volatile("   return                              ");        \
            asm volatile("_os_call_goto_task:                    ");        \
            /*       */                         \
            asm volatile("   rcall   _os_goto_task               ");        \
        }
    
    #define _OS_SaveRetAddr()                                               \
        {                                                                   \
            /*  OS_State         */                       \
            asm volatile("   mov     __OS_CurTask, w0             ");       \
            /*  ,   Delay */                       \
            /*               */                       \
            asm volatile("   disi    #5                          ");        \
            asm volatile("   mov     [w0], w1                    ");        \
            asm volatile("   btss    w1, #4                      ");        \
            asm volatile("   bclr    _OS_state, #4                ");       \
            asm volatile("   mov     _OS_state, w1                ");       \
            asm volatile("   mov     w1, [w0]                    ");        \
            /*     */                          \
        }   


    #define _OS_if_Ready()  if (OS_state.bReady)

//------------------------------------------------------------------------------
extern void _OS_SchedRetPoint (void);
extern void _OS_SchedRetPointNoSave (void);
extern void _OS_CLEAR_READY (void);
extern void _OS_CLEAR_READY_SET_CANCONTINUE (void);

#define _OS_SET_FSR_CUR_TASK_W()
#define _OS_SET_FSR_CUR_TASK()


//------------------------------------------------------------------------------
#define _OS_GetReturnPoint()                    _OS_SchedRetPoint()
//------------------------------------------------------------------------------
//#define _OS_CallGetReturnPoint()                OS_SchedCallRetPoint()
//------------------------------------------------------------------------------
//#define _OS_CLEAR_READY()                       _OS_ClearReady()
//------------------------------------------------------------------------------
//#define _OS_CLEAR_READY_SET_CANCONTINUE()       _OS_ClearReadySetCanContinue()
//------------------------------------------------------------------------------
#define _OS_ReturnNoSave()                      _OS_SchedRetPointNoSave()
//------------------------------------------------------------------------------
    

 



















//______________________________________________________________________________
/******************************************************************************************
 *
 *                                                
 *
 ******************************************************************************************/
//------------------------------------------------------------------------------
#ifdef OS_ENABLE_TIMER
//------------------------------------------------------------------------------




 
 
/******************************************************************************************
 *
 *             P T I M E R '    
 *
 ******************************************************************************************/

#ifdef OS_ENABLE_PTIMERS

#if   OS_TIMER_SIZE == 1
    #define OS_INC_PTIMER()                                                     \
        {                                                                       \
            asm volatile("   mov     [w0 + #4], w2   ");                                 \
            asm volatile("   inc     w2, w2          ");                                 \
            asm volatile("   and     #0xFF, w2       ");                                 \
            asm volatile("   mov     w2, [w0 + #4]   ");                                 \
        }


#elif OS_TIMER_SIZE == 2
    #define OS_INC_PTIMER()                                                     \
        {                                                                       \
            asm volatile("   mov     [w0 + #4], w2   ");                                 \
            asm volatile("   inc     w2, w2          ");                                 \
            asm volatile("   mov     w2, [w0 + #4]   ");                                 \
        }
#elif OS_TIMER_SIZE == 4
    #define OS_INC_PTIMER()                                                     \
        {                                                                       \
            asm volatile("   mov     [w0 + #4], w2   ");                                 \
            asm volatile("   inc     w2, w2          ");                                 \
            asm volatile("   mov     w2, [w0 + #4]   ");                                 \
            asm volatile("   bra     NZ,_OS_PTIMERS_WORK_NEXT      ");                   \
            asm volatile("   mov     [w0 + #6], w2   ");                                 \
            asm volatile("   inc     w2, w2          ");                                 \
            asm volatile("   mov     w2, [w0 + #6]   ");                                 \
        }
#endif




#define _OS_PTIMERS_WORK()                                                      \
    {                                                                           \
        asm volatile("   mov     #__OS_PTimers, w0       ");                             \
        asm volatile("   mov     [w0], w1                "); /* w1 = flags */            \
        asm volatile("_OS_PTIMERS_WORK_NEXT:             ");                             \
        asm volatile("   btss    w1, #3                  "); /* check bNextEnable */     \
        asm volatile("   goto    _OS_PTIMERS_WORK_END    ");                             \
        asm volatile("   mov     [w0 + #2], w0           ");                             \
        asm volatile("   mov     [w0], w1                "); /* w1 = flags */            \
        asm volatile("   btss    w1, #2                  "); /* check bRun */            \
        asm volatile("   goto    _OS_PTIMERS_WORK_NEXT   ");                             \
        OS_INC_PTIMER();                                                        \
        asm volatile("   bra     NZ,_OS_PTIMERS_WORK_NEXT");                             \
        asm volatile("   bset    w1, #0                  "); /* set timeout */           \
        asm volatile("   mov     w1, [w0]                "); /* save flags */            \
        asm volatile("   bra     _OS_PTIMERS_WORK_NEXT   ");                             \
        asm volatile("_OS_PTIMERS_WORK_END:              ");                             \
    }



#define _OS_PTIMERS_WORK_()                             \
    _OS_PTimerWork = (OST_PTIMER*)&_OS_PTimers;         \
    while (_OS_PTimerWork->Flags.bNextEnable) {         \
        _OS_PTimerWork = _OS_PTimerWork->Next;          \
        if (_OS_PTimerWork->Flags.bIsRun) {             \
            if (!++_OS_PTimerWork->Timer)               \
                _OS_PTimerWork->Flags.bTimeout = 1;     \
        }                                               \
    }

#endif  // OS_ENABLE_PTIMER


 
 
 
 
 




/************************************************************************/
/*                                               */
/************************************************************************/
#define __OS_Timer8Work(TIMER_ID,L)                                                                                 \
    {                                                                                                               \
        asm("   btss   _OS_Timeouts + #%0, #%1"::"i"((TIMER_ID >> _OST_INT_SHIFT)),"i"(TIMER_ID & _OST_INT_MASK));    \
        asm("   bra    $ + #12 ");                                                                                   \
        asm("   mov.b    _OS_Timers8+%0, wreg"::"i"(TIMER_ID));                                                     \
        asm("   inc.b    w0, w0     ");                                                                             \
        asm("   mov.b    wreg, _OS_Timers8+%0"::"i"(TIMER_ID));                                                     \
        asm("   bra    NZ, $ + #4");                                                                                \
        asm("   bclr   _OS_Timeouts + #%0, #%1"::"i"((TIMER_ID >> _OST_INT_SHIFT)),"i"(TIMER_ID & _OST_INT_MASK));      \
    }

#define __OS_Timer16Work(TIMER_ID,L)                                                                                \
    {                                                                                                               \
        asm("   btss   _OS_Timeouts + #%0, #%1"::"i"(((TIMER_ID+_OS_TIMER16_POS) >> _OST_INT_SHIFT)),"i"((TIMER_ID+_OS_TIMER16_POS) & _OST_INT_MASK));    \
        asm("   bra    $ + #12 ");                                                                                   \
        asm("   mov    _OS_Timers16+%0, w0"::"i"((TIMER_ID)*2));                                                    \
        asm("   inc    w0, w0     ");                                                                               \
        asm("   mov    w0, _OS_Timers16+%0"::"i"((TIMER_ID)*2));                                                    \
        asm("   bra    NZ, $ + #4");                                                                                \
        asm("   bclr   _OS_Timeouts + #%0, #%1"::"i"(((TIMER_ID+_OS_TIMER16_POS) >> _OST_INT_SHIFT)),"i"((TIMER_ID+_OS_TIMER16_POS) & _OST_INT_MASK));      \
    }

#define __OS_Timer24Work(TIMER_ID,L)                                                                                \
    {                                                                                                               \
        asm("   btss   _OS_Timeouts + #%0, #%1"::"i"(((TIMER_ID+_OS_TIMER24_POS) >> _OST_INT_SHIFT)),"i"((TIMER_ID+_OS_TIMER24_POS) & _OST_INT_MASK));    \
        asm("   bra    $ + 12 ");                                                                                   \
        asm("   mov    _OS_Timers24+%0, w0"::"i"((TIMER_ID)*2));                                    \
        asm("   inc    w0, w0     ");                                                                               \
        asm("   mov    w0, _OS_Timers24+%0"::"i"((TIMER_ID)*2));                                    \
        asm("   bra    NZ, $ + #4");                                                                                \
        asm("   bclr   _OS_Timeouts + #%0, #%1"::"i"(((TIMER_ID+_OS_TIMER24_POS) >> _OST_INT_SHIFT)),"i"((TIMER_ID+_OS_TIMER24_POS) & _OST_INT_MASK));      \
    }

#define __OS_Timer32Work(TIMER_ID,L)                                                                                \
    {                                                                                                               \
        asm("   btss   _OS_Timeouts + #%0, #%1"::"i"(((TIMER_ID+_OS_TIMER32_POS) >> _OST_INT_SHIFT)),"i"((TIMER_ID+_OS_TIMER32_POS) & _OST_INT_MASK));    \
        asm("   bra    $ + #20 ");                                                                                   \
        asm("   mov    _OS_Timers32+%0, w0"::"i"((TIMER_ID+_OS_TIMER32_POS)*4));                                    \
        asm("   inc    w0, w0     ");                                                                               \
        asm("   mov    w0, _OS_Timers32+%0"::"i"((TIMER_ID+_OS_TIMER32_POS)*4));                                    \
        asm("   bra    NZ, $ + #12");                                                                                \
        asm("   mov    _OS_Timers32+%0, w0"::"i"((TIMER_ID+_OS_TIMER32_POS)*4 + 2));                                \
        asm("   inc    w0, w0     ");                                                                               \
        asm("   mov    w0, _OS_Timers32+%0"::"i"((TIMER_ID+_OS_TIMER32_POS)*4 + 2));                                \
        asm("   bra    NZ, $ + #4");                                                                                \
        asm("   bclr   _OS_Timeouts + #%0, #%1"::"i"(((TIMER_ID+_OS_TIMER32_POS) >> _OST_INT_SHIFT)),"i"((TIMER_ID+_OS_TIMER32_POS) & _OST_INT_MASK));    \
    }



#endif  // OS_ENABLE_TIMER



/******************************************************************************************
 *
 *                                             
 *
 ******************************************************************************************/

//#define _OS_SETBIT_BINSEM(binsem)   asm("   bset  _OS_BSems + #%0, #%1"::"i"(((binsem)>>_OST_INT_SHIFT)*2), "i"((binsem)&_OST_INT_MASK));
//#define _OS_CLRBIT_BINSEM(binsem)   asm("   bclr  _OS_BSems + #%0, #%1"::"i"(((binsem)>>_OST_INT_SHIFT)*2), "i"((binsem)&_OST_INT_MASK));
//#define _OS_TGLBIT_BINSEM(binsem)   asm("   btg   _OS_BSems + #%0, #%1"::"i"(((binsem)>>_OST_INT_SHIFT)*2), "i"((binsem)&_OST_INT_MASK));




#endif
